{*-----------------------------------------------------------------------------
Editbio program written by Michael P. Schneider

released into the public domain on Saturday Jan.4 1997

Happy New Year everyone!
-----------------------------------------------------------------------------*}
unit mainbio;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Menus;

type
  TfrmMain = class(TForm)
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Label1: TLabel;
    lblFilename: TLabel;
    FontDialog1: TFontDialog;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    mnuLoad: TMenuItem;
    mnuSave: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    mnuFont: TMenuItem;
    N2: TMenuItem;
    mnuEdit: TMenuItem;
    mnuCut: TMenuItem;
    mnuCopy: TMenuItem;
    mnuPaste: TMenuItem;
    mnuAbout: TMenuItem;
    N3: TMenuItem;
    procedure LoadBio(Sender: TObject);
    procedure SaveBio(Sender: TObject);
    procedure CloseForm(Sender: TObject);
    procedure ChangeFont(Sender: TObject);
    procedure CutText(Sender: TObject);
    procedure CopyText(Sender: TObject);
    procedure PasteText(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
  private
    { Private declarations }
    fBioFilename : string;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

{------------------------------------------------------------------------------}
procedure TfrmMain.LoadBio(Sender: TObject);
  const
    charset = [ 'a'..'z', 'A'..'Z', '0'..'9', ' ',
                '~', '!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '_', '+',
                '|', '`', '-', '=', '\', '{', '}', ':', '"', '<', '>', '?', '[',
                ']', ';', '''', ',', '.', '/'  ];
  var
    ch : char;
    fp : TFilestream;
    tstr : string;
  begin
    if ( opendialog1.execute = true ) then
      begin
        memo1.lines.clear;
        
        { open the file and read it into the memo }
        try
          fBioFilename := opendialog1.filename;
          lblFilename.caption := fBioFilename;
          fp := TFilestream.create( fBioFilename, fmOpenRead );
          while ( fp.position <> fp.size ) do
            begin
              { read in line }
              tstr := '';
              fp.read( ch, 1 );
              while ( ch <> #0 ) do
                begin
                  if ( ch in charset ) then
                    begin
                      appendstr( tstr, ch );
                    end
                  else
                    begin
                      appendstr( tstr, '<' + inttostr( ord( ch ) ) + '>' );
                    end;
                  fp.read( ch, 1 );
                end;
              memo1.lines.add( tstr );
            end;
        finally
          fp.free;
        end; { try..finally }

        mnuSave.enabled := True;
      end
    else
      begin
        fBioFilename := '';
        mnuSave.enabled := False;
      end;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.SaveBio(Sender: TObject);
  var
    x : integer;
    y : integer;
    ch : char;
    fp : TFilestream;
    tstr : string;
  begin
    { Save all of the lines to the file }
    try
      fp := TFilestream.create( fBioFilename, fmOpenWrite );
      for x := 0 to memo1.lines.count-1 do
        begin
          tstr := memo1.lines[x];
          for y := 1 to length( tstr ) do
            begin
              ch := tstr[y];
              fp.write( ch, 1 );
            end;
          ch := #0;
          fp.write( ch, 1 );
        end;

      ch := #0;
      fp.write( ch, 1 );
    finally
      fp.free;
    end; { try..finally }
    
    mnuSave.enabled := False;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.CloseForm(Sender: TObject);
  begin
    close;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.ChangeFont(Sender: TObject);
  begin
    { set the font for viewing }
    if ( FontDialog1.execute ) then
      begin
        memo1.font.assign( FontDialog1.font );
      end;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.CutText(Sender: TObject);
  begin
    Memo1.CutToClipboard;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.CopyText(Sender: TObject);
  begin
    Memo1.CopyToClipboard;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.PasteText(Sender: TObject);
  begin
    Memo1.PasteFromClipboard;
  end;

{------------------------------------------------------------------------------}
procedure TfrmMain.mnuAboutClick(Sender: TObject);
  begin
    ShowMessage(
      'Daggefall Biography Editor' + #13#10 +
      #13#10 +
      'written by Michael P. Schneider ( slannesh@pacbell.net )' 
      );
  end;

{------------------------------------------------------------------------------}
initialization
end.
